#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>         /* for read, write, close */
#include <sys/ioctl.h>      /* for ioctl */
#include <sys/types.h>      /* for open */
#include <sys/stat.h>       /* for open */
#include <fcntl.h>          /* for open */

#include <signal.h>

#include "driver/urc.h"          /* Linux specific part */
#include "driver/urcc.h"          /* Linux specific part */

void exit_program();

int quit_flag = 1;
int fd;

int main(int argc, char **argv){
  struct urcout cmd;
  struct urcin AD_VAL;
  short i, j;
  
  signal(SIGINT, exit_program);

  /* $B%G%P%$%9$N%*!<%W%s(B */
  if ((fd = open("/dev/urc0", O_RDWR)) == -1) {
    fprintf(stderr, "/dev/urc0: Open error\n");
    exit(1);
  }

/* $B%j%H%k%(%s%G%#%"%s$+%S%C%0%(%s%G%#%"%s$+$rD4$Y%G!<%?$NG[CV$rJQ99(B */
#if __BYTE_ORDER == __LITTLE_ENDIAN
  cmd.duty[0] = cmd.duty[1] = cmd.duty[2] = cmd.duty[3] = 0x05D8;
#else
  cmd.offset[0] = cmd.duty[1] = cmd.duty[2] = cmd.duty[3] = 0xD805;
#endif
  if (ioctl(fd, URC_SET) < 0){
    fprintf(stderr, "ioctl: URC_SET error\n");
    exit(1);
  }

  if (write(fd, &cmd, sizeof(cmd)) < 0) {
    fprintf(stderr, "write error\n");
    exit(1);
  }
  
  j=0;

   while(quit_flag) {
     j=(j+1)%2;
     switch(j){
       case 0:
#if __BYTE_ORDER == __LITTLE_ENDIAN
	 cmd.duty[0] = cmd.duty[2] = 0x05D8;
	 cmd.duty[1] = cmd.duty[3] = 0x1387;
#else
	 cmd.duty[0] = cmd.duty[2] = 0xD805;
	 cmd.duty[1] = cmd.duty[3] = 0x8713;
#endif
	 break;
       case 1:
#if __BYTE_ORDER == __LITTLE_ENDIAN
	 cmd.duty[0] = cmd.duty[2] = 0x1387;
	 cmd.duty[1] = cmd.duty[3] = 0x05D8;
#else
	 cmd.duty[0] = cmd.duty[2] = 0x8713;
	 cmd.duty[1] = cmd.duty[3] = 0xD805;
#endif
	 break;
     }

     /* $B%i%8%3%s%5!<%\$NL\I8CM$NJQ99(B */
     if (ioctl(fd, URC_SET) < 0){
       fprintf(stderr, "ioctl: URC_SET error\n");
       exit(1);
     }

     if (write(fd, &cmd, sizeof(cmd)) < 0) {
       fprintf(stderr, "write error\n");
       exit(1);
     }
     
     /* 20ms$B$N(Bwait */
     usleep(2000);
     usleep(2000);
     usleep(2000);
     usleep(2000);
     usleep(2000);
     usleep(2000);
     usleep(2000);
     usleep(2000);
     usleep(2000);

     /* A/D$B%3%s%P!<%?$NJQ49CM$H%^%8%C%/(BNo.$B$N<hF@(B */
     if (ioctl(fd, URC_READ) < 0){
       fprintf(stderr, "ioctl: URC_READ error\n");
       exit(1);
     }

     if ((i = read(fd, &AD_VAL, sizeof(AD_VAL))) != 64) {
       fprintf(stderr, "Warning: read size mismatch (%d!=%d).\n", i, sizeof(AD_VAL));
       continue;
     }

     printf("TIME:%04d MAGIC_NO:%04d CH0:%04d CH1:%04d CH2:%04d CH3:%04d", AD_VAL.time >> 5, AD_VAL.magicno >> 5, AD_VAL.ad[0] >> 5, AD_VAL.ad[1] >> 5, AD_VAL.ad[2] >> 5, AD_VAL.ad[3] >> 5);
     printf("\n");
   
     /* 200ms$B$N(Bwait */
     usleep(200000);
   }
   
   close(fd);

  return 0;
}

void exit_program(sig, code, scp, addr)
int sig;
int code;
struct sigcontext *scp;
char *addr;
{
  quit_flag = 0;
  fprintf(stderr, "kill signal is received\n");
}
